// SPDX-License-Identifier: GPL-3.0-or-later
// SPDX-FileCopyrightText: Andy Holmes <andrew.g.r.holmes@gmail.com>

#include "config.h"

#include <libpeas.h>
#include <valent.h>

#include "valent-fdo-notifications.h"
#include "valent-fdo-session.h"


_VALENT_EXTERN void
valent_fdo_plugin_register_types (PeasObjectModule *module)
{
  /* Although notifications typically only make sense in a graphical
   * environment, it is standard interface that one could implement for devices
   * without a graphical display (i.e. home automation device). */
  peas_object_module_register_extension_type (module,
                                              VALENT_TYPE_NOTIFICATIONS_ADAPTER,
                                              VALENT_TYPE_FDO_NOTIFICATIONS);

  peas_object_module_register_extension_type (module,
                                              VALENT_TYPE_SESSION_ADAPTER,
                                              VALENT_TYPE_FDO_SESSION);
}
